<template>
    <div>
        <div class="row mt-2">
        </div>
        <table class="table w-50  table-striped" v-if="usuarioStore.listadoUsuariosSolicitantes.length > 0">
            <thead>
                <tr>
                    <th scope="col">Solicitante</th>
                    <th scope="col">Acciones</th>
                </tr>
            </thead>
            <tbody>
                <tr v-for="usuario in usuarioStore.listadoUsuariosSolicitantes" :key="usuario.id_usuario_solicitante">
                    <td v-text="usuario.d_solicitante"></td>
                    <td>
                        <button  class="btn btn-borrar-table  mx-2 text-uppercase p-0 px-2 fs-5" alt="Borrar" title="Borrar"
                            @click="borrar(usuario.id_usuario_solicitante)">
                            <i class="fa-solid fa-trash-can"></i>
                        </button>
                    </td>
                </tr>
            </tbody>
        </table>
        <div v-else class="alert alert-secondary" role="alert">
            No hay elementos para mostrar
        </div>
    </div>
</template>
  
<script setup lang="ts">
//librerias
import { reactive, onMounted } from "vue";
import { useRoute, useRouter } from "vue-router";
import { loading, urlApi } from "@/shared.js";
import http from "@/http";
import Swal from "sweetalert2/dist/sweetalert2.js";
import { AxiosError } from "axios";
//Entities
import type { Usuariohabilitado } from "@/entities/Usuariohabilitado";
//Stores
import { useUsuariosStore } from "@/stores/usuarios";

const route = useRoute();
const router = useRouter();

const usuarioStore = useUsuariosStore();

var data = reactive({
    usuarioHabilitado: {} as Usuariohabilitado | undefined,

});


async function borrar(id_usuario_solicitante: Number) {
    Swal.fire({
        icon: "question",
        title: "Confirmaci&oacute;n",
        html: "¿Confirma la eliminaci&oacute;n del Usuario? Esta acci&oacute;n no podr&aacute; ser revertida.",
        showCancelButton: true,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Confirmar",
        cancelButtonText: "Cancelar",
    }).then(async (result) => {
        if (result.isConfirmed) {
            loading.show();
            try {
                var rta = await http.post(urlApi + "deleteUsuarioSolicitante", {
                    id_usuario_solicitante: id_usuario_solicitante,
                });
                if (rta.data.status == "success") {
                    Swal.fire({
                        icon: "success",
                        text: "Se borro el Solicitante.",
                    }).then(async () => {
                        await usuarioStore.updateListadoUsuariosSolicitantes({
                            id_usuario_perfil: data.usuarioHabilitado?.id_usuario_perfil,
                        });
                    });
                    loading.hide();
                } else {
                    Swal.fire({
                        icon: "error",
                        text: rta.data.message,
                    });
                    loading.hide();
                }
            } catch (error: any) {
                var mensaje: string = error.message;

                if (error instanceof AxiosError) {
                    mensaje = error.response?.data.res.mensaje;
                }
                Swal.fire({
                    icon: "error",
                    text: mensaje,
                });
            }
        }
    });

}

onMounted(async () => {

    loading.show();
    if (route.params.id != undefined) {
        data.usuarioHabilitado = await usuarioStore.findUsuarioById(Number (route.params.id));
        await usuarioStore.updateListadoUsuariosSolicitantes({
            id_usuario_perfil: data.usuarioHabilitado?.id_usuario_perfil,
        });
    }
    loading.hide();

});

</script>
  